Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/HeuristicLab.Hive.Server.ADODataAccess-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/HeuristicLab.Hive.Server.ADODataAccess-3.2.csproj	(revision 1946)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/HeuristicLab.Hive.Server.ADODataAccess-3.2.csproj	(revision 1947)
@@ -82,4 +82,5 @@
     <Compile Include="ClientAdapter.cs" />
     <Compile Include="ClientGroupAdapter.cs" />
+    <Compile Include="ProjectAdapter.cs" />
     <Compile Include="dsHiveServer.cs">
       <DependentUpon>dsHiveServer.xsd</DependentUpon>
@@ -105,4 +106,6 @@
     <Compile Include="TableAdapterWrapper\ClientGroupAdapterWrapper.cs" />
     <Compile Include="TableAdapterWrapper\ClientGroup_ResourceAdapterWrapper.cs" />
+    <Compile Include="TableAdapterWrapper\AssignedResourcesAdapterWrapper.cs" />
+    <Compile Include="TableAdapterWrapper\ProjectAdapterWrapper.cs" />
     <Compile Include="TableAdapterWrapper\RequiredPluginsAdapterWrapper.cs" />
     <Compile Include="TableAdapterWrapper\PluginInfoAdapterWrapper.cs" />
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/JobAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/JobAdapter.cs	(revision 1946)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/JobAdapter.cs	(revision 1947)
@@ -42,19 +42,39 @@
     private ManyToManyRelationHelper<
       dsHiveServerTableAdapters.RequiredPluginsTableAdapter,
-      dsHiveServer.RequiredPluginsRow> manyToManyRelationHelper = null;
+      dsHiveServer.RequiredPluginsRow> pluginsManyToManyRelationHelper = null;
 
     private ManyToManyRelationHelper<
       dsHiveServerTableAdapters.RequiredPluginsTableAdapter,
-      dsHiveServer.RequiredPluginsRow> ManyToManyRelationHelper {
-      get {
-        if (manyToManyRelationHelper == null) {
-          manyToManyRelationHelper =
+      dsHiveServer.RequiredPluginsRow> PluginsManyToManyRelationHelper {
+      get {
+        if (pluginsManyToManyRelationHelper == null) {
+          pluginsManyToManyRelationHelper =
             new ManyToManyRelationHelper<dsHiveServerTableAdapters.RequiredPluginsTableAdapter,
               dsHiveServer.RequiredPluginsRow>(new RequiredPluginsAdapterWrapper(), 1);
         }
 
-        manyToManyRelationHelper.Session = Session as Session;
-
-        return manyToManyRelationHelper;
+        pluginsManyToManyRelationHelper.Session = Session as Session;
+
+        return pluginsManyToManyRelationHelper;
+      }
+    }
+
+    private ManyToManyRelationHelper<
+      dsHiveServerTableAdapters.AssignedResourcesTableAdapter,
+      dsHiveServer.AssignedResourcesRow> assignedManyToManyRelationHelper = null;
+
+    private ManyToManyRelationHelper<
+      dsHiveServerTableAdapters.AssignedResourcesTableAdapter,
+      dsHiveServer.AssignedResourcesRow> AssignedManyToManyRelationHelper {
+      get {
+        if (assignedManyToManyRelationHelper == null) {
+          assignedManyToManyRelationHelper =
+            new ManyToManyRelationHelper<dsHiveServerTableAdapters.AssignedResourcesTableAdapter,
+              dsHiveServer.AssignedResourcesRow>(new AssignedResourcesAdapterWrapper(), 0);
+        }
+
+        assignedManyToManyRelationHelper.Session = Session as Session;
+
+        return assignedManyToManyRelationHelper;
       }
     }
@@ -95,4 +115,17 @@
 
         return pluginInfoAdapter;
+      }
+    }
+
+    private IProjectAdapter projectAdapter = null;
+
+    private IProjectAdapter ProjectAdapter {
+      get {
+        if (projectAdapter == null) {
+          projectAdapter =
+            this.Session.GetDataAdapter<Project, IProjectAdapter>();
+        }
+
+        return projectAdapter;
       }
     }
@@ -163,6 +196,12 @@
           job.MemoryNeeded = default(int);
 
+        if (!row.IsProjectIdNull())
+          job.Project = ProjectAdapter.GetById(
+            row.ProjectId);
+        else
+          job.Project = null;
+
         ICollection<Guid> requiredPlugins =
-          ManyToManyRelationHelper.GetRelationships(job.Id);
+          PluginsManyToManyRelationHelper.GetRelationships(job.Id);
         
         job.PluginsNeeded.Clear();
@@ -173,4 +212,8 @@
           job.PluginsNeeded.Add(pluginInfo);
         }
+
+        job.AssignedResourceIds =
+          new List<Guid>(
+            AssignedManyToManyRelationHelper.GetRelationships(job.Id));
 
         return job;
@@ -234,4 +277,9 @@
 
         row.MemoryNeeded = job.MemoryNeeded;
+
+        if (job.Project != null)
+          row.ProjectId = job.Project.Id;
+        else
+          row.SetProjectIdNull();
       }
 
@@ -303,8 +351,14 @@
 
     public ICollection<Job> GetJobsByProject(Guid projectId) {
-      throw new NotImplementedException();
+      return
+         base.FindMultiple(
+           delegate() {
+             return Adapter.GetDataByProjectId(projectId);
+           });
     }
 
     protected override void doUpdate(Job obj) {
+      ProjectAdapter.Update(obj.Project);
+      
       base.doUpdate(obj);
 
@@ -324,6 +378,9 @@
       }
 
-      ManyToManyRelationHelper.UpdateRelationships(
+      PluginsManyToManyRelationHelper.UpdateRelationships(
         obj.Id, relationships);
+
+      AssignedManyToManyRelationHelper.UpdateRelationships(
+        obj.Id, obj.AssignedResourceIds);
     }
 
@@ -343,5 +400,5 @@
 
           //delete all relationships
-          ManyToManyRelationHelper.UpdateRelationships(job.Id,
+          PluginsManyToManyRelationHelper.UpdateRelationships(job.Id,
             new List<Guid>());
 
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ProjectAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ProjectAdapter.cs	(revision 1947)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ProjectAdapter.cs	(revision 1947)
@@ -0,0 +1,81 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Server.DataAccess;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Linq.Expressions;
+using HeuristicLab.DataAccess.Interfaces;
+using HeuristicLab.DataAccess.ADOHelper;
+using HeuristicLab.Hive.Server.ADODataAccess.dsHiveServerTableAdapters;
+using System.Data.Common;
+using System.Data.SqlClient;
+using HeuristicLab.Hive.Server.ADODataAccess.TableAdapterWrapper;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess {
+  class ProjectAdapter: 
+    DataAdapterBase<
+      dsHiveServerTableAdapters.ProjectTableAdapter, 
+      Project, 
+      dsHiveServer.ProjectRow>,
+    IProjectAdapter{
+    public ProjectAdapter(): 
+      base(new ProjectAdapterWrapper()) {
+    }
+
+    #region Overrides
+    protected override Project ConvertRow(dsHiveServer.ProjectRow row, 
+      Project project) {
+      if (row != null && project != null) {
+        project.Id = row.ProjectId;
+
+        if (!row.IsNameNull())
+          project.Name = row.Name;
+        else
+          project.Name = null;
+
+        return project;
+      }
+      else
+        return null;
+    }
+
+    protected override dsHiveServer.ProjectRow ConvertObj(Project project,
+      dsHiveServer.ProjectRow row) {
+      if (project != null && row != null) {
+        row.ProjectId = project.Id;
+
+        if (project.Name != null)
+          row.Name = project.Name;
+        else
+          row.SetNameNull();
+      }
+
+      return row;
+    }
+
+    #endregion
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/AssignedResourcesAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/AssignedResourcesAdapterWrapper.cs	(revision 1947)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/AssignedResourcesAdapterWrapper.cs	(revision 1947)
@@ -0,0 +1,54 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using System.Data.SqlClient;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Data.Common;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess.TableAdapterWrapper {
+  class AssignedResourcesAdapterWrapper :
+  TableAdapterWrapperBase<dsHiveServerTableAdapters.AssignedResourcesTableAdapter,
+  ManyToManyRelation,
+  dsHiveServer.AssignedResourcesRow> {
+    public override dsHiveServer.AssignedResourcesRow
+     InsertNewRow(ManyToManyRelation relation) {
+      dsHiveServer.AssignedResourcesDataTable data =
+         new dsHiveServer.AssignedResourcesDataTable();
+
+      dsHiveServer.AssignedResourcesRow row =
+        data.NewAssignedResourcesRow();
+
+      row.JobId = relation.Id;
+      row.ResourceId = relation.Id2;
+
+      data.AddAssignedResourcesRow(row);
+
+      return row;
+    }
+
+    public override void
+      UpdateRow(dsHiveServer.AssignedResourcesRow row) {
+      TransactionalAdapter.Update(row);
+    }
+
+    public override IEnumerable<dsHiveServer.AssignedResourcesRow>
+      FindById(Guid id) {
+      return TransactionalAdapter.GetDataByJobId(id);
+    }
+
+    public override IEnumerable<dsHiveServer.AssignedResourcesRow>
+      FindAll() {
+      return TransactionalAdapter.GetData();
+    }
+
+    protected override void SetConnection(DbConnection connection) {
+      adapter.Connection = connection as SqlConnection;
+    }
+
+    protected override void SetTransaction(DbTransaction transaction) {
+      adapter.Transaction = transaction as SqlTransaction;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ProjectAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ProjectAdapterWrapper.cs	(revision 1947)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ProjectAdapterWrapper.cs	(revision 1947)
@@ -0,0 +1,49 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using System.Data.SqlClient;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Data.Common;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess.TableAdapterWrapper {
+  class ProjectAdapterWrapper :
+    TableAdapterWrapperBase<dsHiveServerTableAdapters.ProjectTableAdapter,
+                      Project,
+                      dsHiveServer.ProjectRow> {
+    public override void UpdateRow(dsHiveServer.ProjectRow row) {
+      TransactionalAdapter.Update(row);
+    }
+
+    public override dsHiveServer.ProjectRow
+      InsertNewRow(Project project) {
+      dsHiveServer.ProjectDataTable data =
+        new dsHiveServer.ProjectDataTable();
+
+      dsHiveServer.ProjectRow row = data.NewProjectRow();
+      row.ProjectId = project.Id;
+      data.AddProjectRow(row);
+
+      return row;
+    }
+
+    public override IEnumerable<dsHiveServer.ProjectRow>
+      FindById(Guid id) {
+      return TransactionalAdapter.GetDataById(id);
+    }
+
+    public override IEnumerable<dsHiveServer.ProjectRow>
+      FindAll() {
+      return TransactionalAdapter.GetData();
+    }
+
+    protected override void SetConnection(DbConnection connection) {
+      adapter.Connection = connection as SqlConnection;
+    }
+
+    protected override void SetTransaction(DbTransaction transaction) {
+      adapter.Transaction = transaction as SqlTransaction;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/dsHiveServer.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/dsHiveServer.Designer.cs	(revision 1946)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/dsHiveServer.Designer.cs	(revision 1947)
@@ -42,4 +42,8 @@
         private PluginInfoDataTable tablePluginInfo;
         
+        private ProjectDataTable tableProject;
+        
+        private AssignedResourcesDataTable tableAssignedResources;
+        
         private global::System.Data.DataRelation relationClient_is_a_Resource;
         
@@ -61,4 +65,10 @@
         
         private global::System.Data.DataRelation relationR_521;
+        
+        private global::System.Data.DataRelation relationR_49;
+        
+        private global::System.Data.DataRelation relationR_55;
+        
+        private global::System.Data.DataRelation relationR_56;
         
         private global::System.Data.SchemaSerializationMode _schemaSerializationMode = global::System.Data.SchemaSerializationMode.IncludeSchema;
@@ -112,4 +122,10 @@
                     base.Tables.Add(new PluginInfoDataTable(ds.Tables["PluginInfo"]));
                 }
+                if ((ds.Tables["Project"] != null)) {
+                    base.Tables.Add(new ProjectDataTable(ds.Tables["Project"]));
+                }
+                if ((ds.Tables["AssignedResources"] != null)) {
+                    base.Tables.Add(new AssignedResourcesDataTable(ds.Tables["AssignedResources"]));
+                }
                 this.DataSetName = ds.DataSetName;
                 this.Prefix = ds.Prefix;
@@ -203,4 +219,22 @@
         
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.ComponentModel.Browsable(false)]
+        [global::System.ComponentModel.DesignerSerializationVisibility(global::System.ComponentModel.DesignerSerializationVisibility.Content)]
+        public ProjectDataTable Project {
+            get {
+                return this.tableProject;
+            }
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.ComponentModel.Browsable(false)]
+        [global::System.ComponentModel.DesignerSerializationVisibility(global::System.ComponentModel.DesignerSerializationVisibility.Content)]
+        public AssignedResourcesDataTable AssignedResources {
+            get {
+                return this.tableAssignedResources;
+            }
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
         [global::System.ComponentModel.BrowsableAttribute(true)]
         [global::System.ComponentModel.DesignerSerializationVisibilityAttribute(global::System.ComponentModel.DesignerSerializationVisibility.Visible)]
@@ -284,4 +318,10 @@
                 if ((ds.Tables["PluginInfo"] != null)) {
                     base.Tables.Add(new PluginInfoDataTable(ds.Tables["PluginInfo"]));
+                }
+                if ((ds.Tables["Project"] != null)) {
+                    base.Tables.Add(new ProjectDataTable(ds.Tables["Project"]));
+                }
+                if ((ds.Tables["AssignedResources"] != null)) {
+                    base.Tables.Add(new AssignedResourcesDataTable(ds.Tables["AssignedResources"]));
                 }
                 this.DataSetName = ds.DataSetName;
@@ -361,4 +401,16 @@
                 if ((this.tablePluginInfo != null)) {
                     this.tablePluginInfo.InitVars();
+                }
+            }
+            this.tableProject = ((ProjectDataTable)(base.Tables["Project"]));
+            if ((initTable == true)) {
+                if ((this.tableProject != null)) {
+                    this.tableProject.InitVars();
+                }
+            }
+            this.tableAssignedResources = ((AssignedResourcesDataTable)(base.Tables["AssignedResources"]));
+            if ((initTable == true)) {
+                if ((this.tableAssignedResources != null)) {
+                    this.tableAssignedResources.InitVars();
                 }
             }
@@ -373,4 +425,7 @@
             this.relationR_47 = this.Relations["R_47"];
             this.relationR_521 = this.Relations["R_521"];
+            this.relationR_49 = this.Relations["R_49"];
+            this.relationR_55 = this.Relations["R_55"];
+            this.relationR_56 = this.Relations["R_56"];
         }
         
@@ -398,4 +453,8 @@
             this.tablePluginInfo = new PluginInfoDataTable();
             base.Tables.Add(this.tablePluginInfo);
+            this.tableProject = new ProjectDataTable();
+            base.Tables.Add(this.tableProject);
+            this.tableAssignedResources = new AssignedResourcesDataTable();
+            base.Tables.Add(this.tableAssignedResources);
             this.relationClient_is_a_Resource = new global::System.Data.DataRelation("Client_is_a_Resource", new global::System.Data.DataColumn[] {
                         this.tableResource.ResourceIdColumn}, new global::System.Data.DataColumn[] {
@@ -438,4 +497,16 @@
                         this.tableClientGroup_Resource.ClientGroupIdColumn}, false);
             this.Relations.Add(this.relationR_521);
+            this.relationR_49 = new global::System.Data.DataRelation("R_49", new global::System.Data.DataColumn[] {
+                        this.tableProject.ProjectIdColumn}, new global::System.Data.DataColumn[] {
+                        this.tableJob.ProjectIdColumn}, false);
+            this.Relations.Add(this.relationR_49);
+            this.relationR_55 = new global::System.Data.DataRelation("R_55", new global::System.Data.DataColumn[] {
+                        this.tableResource.ResourceIdColumn}, new global::System.Data.DataColumn[] {
+                        this.tableAssignedResources.ResourceIdColumn}, false);
+            this.Relations.Add(this.relationR_55);
+            this.relationR_56 = new global::System.Data.DataRelation("R_56", new global::System.Data.DataColumn[] {
+                        this.tableJob.JobIdColumn}, new global::System.Data.DataColumn[] {
+                        this.tableAssignedResources.JobIdColumn}, false);
+            this.Relations.Add(this.relationR_56);
         }
         
@@ -477,4 +548,14 @@
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
         private bool ShouldSerializePluginInfo() {
+            return false;
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        private bool ShouldSerializeProject() {
+            return false;
+        }
+        
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        private bool ShouldSerializeAssignedResources() {
             return false;
         }
@@ -548,4 +629,8 @@
         
         public delegate void PluginInfoRowChangeEventHandler(object sender, PluginInfoRowChangeEvent e);
+        
+        public delegate void ProjectRowChangeEventHandler(object sender, ProjectRowChangeEvent e);
+        
+        public delegate void AssignedResourcesRowChangeEventHandler(object sender, AssignedResourcesRowChangeEvent e);
         
         /// <summary>
@@ -1811,5 +1896,5 @@
             
             [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-            public JobRow AddJobRow(System.Guid JobId, System.Guid ParentJobId, string JobState, ClientRow parentClientRowByR_21, double Percentage, byte[] SerializedJob, System.DateTime DateCreated, System.DateTime DateCalculated, int Priority, System.Guid ProjectId, System.Guid UserId, int CoresNeeded, int MemoryNeeded) {
+            public JobRow AddJobRow(System.Guid JobId, System.Guid ParentJobId, string JobState, ClientRow parentClientRowByR_21, double Percentage, byte[] SerializedJob, System.DateTime DateCreated, System.DateTime DateCalculated, int Priority, ProjectRow parentProjectRowByR_49, System.Guid UserId, int CoresNeeded, int MemoryNeeded) {
                 JobRow rowJobRow = ((JobRow)(this.NewRow()));
                 object[] columnValuesArray = new object[] {
@@ -1823,5 +1908,5 @@
                         DateCalculated,
                         Priority,
-                        ProjectId,
+                        null,
                         UserId,
                         CoresNeeded,
@@ -1829,4 +1914,7 @@
                 if ((parentClientRowByR_21 != null)) {
                     columnValuesArray[3] = parentClientRowByR_21[0];
+                }
+                if ((parentProjectRowByR_49 != null)) {
+                    columnValuesArray[9] = parentProjectRowByR_49[0];
                 }
                 rowJobRow.ItemArray = columnValuesArray;
